Index: src/parser.cpp
===================================================================
--- src/parser.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/parser.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -32,5 +32,5 @@
   if (input == NULL) {
     if (!test)
-      DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << filename << ", is the directory correct?" << endl);
+      DoLog(0) && (Log() << Verbose(0) << endl << "FilePresent: Unable to open " << filename << ", is the directory correct?" << endl);
     return false;
   }
@@ -59,8 +59,8 @@
 MatrixContainer::MatrixContainer() {
   Indices = NULL;
-  Header = Malloc<char*>(1, "MatrixContainer::MatrixContainer: **Header");
-  Matrix = Malloc<double**>(1, "MatrixContainer::MatrixContainer: ***Matrix"); // one more each for the total molecule
-  RowCounter = Malloc<int>(1, "MatrixContainer::MatrixContainer: *RowCounter");
-  ColumnCounter = Malloc<int>(1, "MatrixContainer::MatrixContainer: *ColumnCounter");
+  Header = new char*[1];
+  Matrix = new double**[1]; // one more each for the total molecule
+  RowCounter = new int[1];
+  ColumnCounter = new int[1];
   Header[0] = NULL;
   Matrix[0] = NULL;
@@ -77,27 +77,27 @@
       if ((ColumnCounter != NULL) && (RowCounter != NULL)) {
           for(int j=RowCounter[i]+1;j--;)
-            Free(&Matrix[i][j]);
-        Free(&Matrix[i]);
+            delete[](Matrix[i][j]);
+          delete[](Matrix[i]);
       }
     }
     if ((ColumnCounter != NULL) && (RowCounter != NULL) && (Matrix[MatrixCounter] != NULL))
       for(int j=RowCounter[MatrixCounter]+1;j--;)
-        Free(&Matrix[MatrixCounter][j]);
+        delete[](Matrix[MatrixCounter][j]);
     if (MatrixCounter != 0)
-      Free(&Matrix[MatrixCounter]);
-    Free(&Matrix);
+      delete[](Matrix[MatrixCounter]);
+    delete[](Matrix);
   }
   if (Indices != NULL)
     for(int i=MatrixCounter+1;i--;) {
-      Free(&Indices[i]);
-    }
-  Free(&Indices);
+      delete[](Indices[i]);
+    }
+  delete[](Indices);
   
   if (Header != NULL)
     for(int i=MatrixCounter+1;i--;)
-      Free(&Header[i]);
-  Free(&Header);
-  Free(&RowCounter);
-  Free(&ColumnCounter);
+      delete[](Header[i]);
+  delete[](Header);
+  delete[](RowCounter);
+  delete[](ColumnCounter);
 };
 
@@ -112,7 +112,7 @@
   if (Matrix == NULL) {
     DoLog(0) && (Log() << Verbose(0) << " with trivial mapping." << endl);
-    Indices = Malloc<int*>(MatrixCounter + 1, "MatrixContainer::InitialiseIndices: **Indices");
+    Indices = new int*[MatrixCounter + 1];
     for(int i=MatrixCounter+1;i--;) {
-      Indices[i] = Malloc<int>(RowCounter[i], "MatrixContainer::InitialiseIndices: *Indices[]");
+      Indices[i] = new int[RowCounter[i]];
       for(int j=RowCounter[i];j--;)
         Indices[i][j] = j;
@@ -122,9 +122,9 @@
     if (MatrixCounter != Matrix->MatrixCounter)
       return false;
-    Indices = Malloc<int*>(MatrixCounter + 1, "MatrixContainer::InitialiseIndices: **Indices");
+    Indices = new int*[MatrixCounter + 1];
     for(int i=MatrixCounter+1;i--;) {
       if (RowCounter[i] != Matrix->RowCounter[i])
         return false;
-      Indices[i] = Malloc<int>(Matrix->RowCounter[i], "MatrixContainer::InitialiseIndices: *Indices[]");
+      Indices[i] = new int[Matrix->RowCounter[i]];
       for(int j=Matrix->RowCounter[i];j--;) {
         Indices[i][j] = Matrix->Indices[i][j];
@@ -160,5 +160,5 @@
   //Log() << Verbose(1) << "Opening " << name << " ... "  << input << endl;
   if (input == NULL) {
-    DoeLog(1) && (eLog()<< Verbose(1) << endl << "Unable to open " << name << ", is the directory correct?" << endl);
+    DoeLog(1) && (eLog()<< Verbose(1) << endl << "MatrixContainer::ParseMatrix: Unable to open " << name << ", is the directory correct?" << endl);
     //performCriticalExit();
     return false;
@@ -166,5 +166,5 @@
 
   // parse header
-  Header[MatrixNr] = Malloc<char>(1024, "MatrixContainer::ParseMatrix: *Header[]");
+  Header[MatrixNr] = new char[1024];
   for (int m=skiplines+1;m--;)
     input.getline(Header[MatrixNr], 1023);
@@ -205,5 +205,5 @@
   // allocate matrix if it's not zero dimension in one direction
   if ((ColumnCounter[MatrixNr] > 0) && (RowCounter[MatrixNr] > -1)) {
-    Matrix[MatrixNr] = Malloc<double*>(RowCounter[MatrixNr] + 1, "MatrixContainer::ParseMatrix: **Matrix[]");
+    Matrix[MatrixNr] = new double*[RowCounter[MatrixNr] + 1];
   
     // parse in each entry for this matrix
@@ -217,5 +217,5 @@
     strncpy(Header[MatrixNr], line.str().c_str(), 1023);  
     for(int j=0;j<RowCounter[MatrixNr];j++) {
-      Matrix[MatrixNr][j] = Malloc<double>(ColumnCounter[MatrixNr], "MatrixContainer::ParseMatrix: *Matrix[][]");
+      Matrix[MatrixNr][j] = new double[ColumnCounter[MatrixNr]];
       input.getline(filename, 1023);
       stringstream lines(filename);
@@ -227,5 +227,5 @@
         //Log() << Verbose(1) << " " << setprecision(2) << Matrix[MatrixNr][j][k] << endl;
       }
-      Matrix[MatrixNr][ RowCounter[MatrixNr] ] = Malloc<double>(ColumnCounter[MatrixNr], "MatrixContainer::ParseMatrix: *Matrix[RowCounter[MatrixNr]][]");
+      Matrix[MatrixNr][ RowCounter[MatrixNr] ] = new double[ColumnCounter[MatrixNr]];
       for(int j=ColumnCounter[MatrixNr];j--;)
         Matrix[MatrixNr][ RowCounter[MatrixNr] ][j] = 0.;
@@ -269,5 +269,5 @@
   input.open(file.str().c_str(), ios::in);
   if (input == NULL) {
-    DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl);
+    DoLog(0) && (Log() << Verbose(0) << endl << "MatrixContainer::ParseFragmentMatrix: Unable to open " << file.str() << ", is the directory correct?" << endl);
     return false;
   }
@@ -281,8 +281,12 @@
 
   DoLog(0) && (Log() << Verbose(0) << "Parsing through each fragment and retrieving " << prefix << suffix << "." << endl);
-  Header = ReAlloc<char*>(Header, MatrixCounter + 1, "MatrixContainer::ParseFragmentMatrix: **Header"); // one more each for the total molecule
-  Matrix = ReAlloc<double**>(Matrix, MatrixCounter + 1, "MatrixContainer::ParseFragmentMatrix: ***Matrix"); // one more each for the total molecule
-  RowCounter = ReAlloc<int>(RowCounter, MatrixCounter + 1, "MatrixContainer::ParseFragmentMatrix: *RowCounter");
-  ColumnCounter = ReAlloc<int>(ColumnCounter, MatrixCounter + 1, "MatrixContainer::ParseFragmentMatrix: *ColumnCounter");
+  delete[](Header);
+  delete[](Matrix);
+  delete[](RowCounter);
+  delete[](ColumnCounter);
+  Header = new char*[MatrixCounter + 1]; // one more each for the total molecule
+  Matrix = new double**[MatrixCounter + 1]; // one more each for the total molecule
+  RowCounter = new int[MatrixCounter + 1];
+  ColumnCounter = new int[MatrixCounter + 1];
   for(int i=MatrixCounter+1;i--;) {
     Matrix[i] = NULL;
@@ -298,5 +302,5 @@
     if (!ParseMatrix(file.str().c_str(), skiplines, skipcolumns, i))
       return false;
-    Free(&FragmentNumber);
+    delete[](FragmentNumber);
   }
   return true;
@@ -313,16 +317,16 @@
 {
   MatrixCounter = MCounter;
-  Header = Malloc<char*>(MatrixCounter + 1, "MatrixContainer::AllocateMatrix: *Header");
-  Matrix = Malloc<double**>(MatrixCounter + 1, "MatrixContainer::AllocateMatrix: ***Matrix"); // one more each for the total molecule
-  RowCounter = Malloc<int>(MatrixCounter + 1, "MatrixContainer::AllocateMatrix: *RowCounter");
-  ColumnCounter = Malloc<int>(MatrixCounter + 1, "MatrixContainer::AllocateMatrix: *ColumnCounter");
+  Header = new char*[MatrixCounter + 1];
+  Matrix = new double**[MatrixCounter + 1]; // one more each for the total molecule
+  RowCounter = new int[MatrixCounter + 1];
+  ColumnCounter = new int[MatrixCounter + 1];
   for(int i=MatrixCounter+1;i--;) {
-    Header[i] = Malloc<char>(1024, "MatrixContainer::AllocateMatrix: *Header[i]");
+    Header[i] = new char[1024];
     strncpy(Header[i], GivenHeader[i], 1023);
     RowCounter[i] = RCounter[i];
     ColumnCounter[i] = CCounter[i];
-    Matrix[i] = Malloc<double*>(RowCounter[i] + 1, "MatrixContainer::AllocateMatrix: **Matrix[]");
+    Matrix[i] = new double*[RowCounter[i] + 1];
     for(int j=RowCounter[i]+1;j--;) {
-      Matrix[i][j] = Malloc<double>(ColumnCounter[i], "MatrixContainer::AllocateMatrix: *Matrix[][]");
+      Matrix[i][j] = new double[ColumnCounter[i]];
       for(int k=ColumnCounter[i];k--;)
         Matrix[i][j][k] = 0.;
@@ -474,8 +478,8 @@
     FragmentNumber = FixedDigitNumber(MatrixCounter, i);
     line << name << FRAGMENTPREFIX << FragmentNumber << "/" << prefix;
-    Free(&FragmentNumber);
+    delete[](FragmentNumber);
     output.open(line.str().c_str(), ios::out);
     if (output == NULL) {
-      DoeLog(0) && (eLog()<< Verbose(0) << "Unable to open output energy file " << line.str() << "!" << endl);
+      DoeLog(0) && (eLog()<< Verbose(0) << "MatrixContainer::WriteTotalFragments: Unable to open output energy file " << line.str() << "!" << endl);
       performCriticalExit();
       return false;
@@ -507,5 +511,5 @@
   output.open(line.str().c_str(), ios::out);
   if (output == NULL) {
-    DoeLog(0) && (eLog()<< Verbose(0) << "Unable to open output matrix file " << line.str() << "!" << endl);
+    DoeLog(0) && (eLog()<< Verbose(0) << "MatrixContainer::WriteLastMatrix: Unable to open output matrix file " << line.str() << "!" << endl);
     performCriticalExit();
     return false;
@@ -530,7 +534,7 @@
 {
   DoLog(0) && (Log() << Verbose(0) << "Parsing energy indices." << endl);
-  Indices = Malloc<int*>(MatrixCounter + 1, "EnergyMatrix::ParseIndices: **Indices");
+  Indices = new int*[MatrixCounter + 1];
   for(int i=MatrixCounter+1;i--;) {
-    Indices[i] = Malloc<int>(RowCounter[i], "EnergyMatrix::ParseIndices: *Indices[]");
+    Indices[i] = new int[RowCounter[i]];
     for(int j=RowCounter[i];j--;)
       Indices[i][j] = j;
@@ -589,7 +593,7 @@
     // allocate last plus one matrix
     DoLog(0) && (Log() << Verbose(0) << "Allocating last plus one matrix with " << (RowCounter[MatrixCounter]+1) << " rows and " << ColumnCounter[MatrixCounter] << " columns." << endl);
-    Matrix[MatrixCounter] = Malloc<double*>(RowCounter[MatrixCounter] + 1, "MatrixContainer::ParseFragmentMatrix: **Matrix[]");
+    Matrix[MatrixCounter] = new double*[RowCounter[MatrixCounter] + 1];
     for(int j=0;j<=RowCounter[MatrixCounter];j++)
-      Matrix[MatrixCounter][j] = Malloc<double>(ColumnCounter[MatrixCounter], "MatrixContainer::ParseFragmentMatrix: *Matrix[][]");
+      Matrix[MatrixCounter][j] = new double[ColumnCounter[MatrixCounter]];
     
     // try independently to parse global energysuffix file if present
@@ -616,10 +620,10 @@
 
   DoLog(0) && (Log() << Verbose(0) << "Parsing force indices for " << MatrixCounter << " matrices." << endl);
-  Indices = Malloc<int*>(MatrixCounter + 1, "ForceMatrix::ParseIndices: **Indices");
+  Indices = new int*[MatrixCounter + 1];
   line << name << FRAGMENTPREFIX << FORCESFILE;
   input.open(line.str().c_str(), ios::in);
   //Log() << Verbose(0) << "Opening " << line.str() << " ... "  << input << endl;
   if (input == NULL) {
-    DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << line.str() << ", is the directory correct?" << endl);
+    DoLog(0) && (Log() << Verbose(0) << endl << "ForceMatrix::ParseIndices: Unable to open " << line.str() << ", is the directory correct?" << endl);
     return false;
   }
@@ -629,8 +633,8 @@
     line.str(filename);
     // parse the values
-    Indices[i] = Malloc<int>(RowCounter[i], "ForceMatrix::ParseIndices: *Indices[]");
+    Indices[i] = new int[RowCounter[i]];
     FragmentNumber = FixedDigitNumber(MatrixCounter, i);
     //Log() << Verbose(0) << FRAGMENTPREFIX << FragmentNumber << "[" << RowCounter[i] << "]:";
-    Free(&FragmentNumber);
+    delete[](FragmentNumber);
     for(int j=0;(j<RowCounter[i]) && (!line.eof());j++) {
       line >> Indices[i][j];
@@ -639,5 +643,5 @@
     //Log() << Verbose(0) << endl;
   }
-  Indices[MatrixCounter] = Malloc<int>(RowCounter[MatrixCounter], "ForceMatrix::ParseIndices: *Indices[]");
+  Indices[MatrixCounter] = new int[RowCounter[MatrixCounter]];
   for(int j=RowCounter[MatrixCounter];j--;) {
     Indices[MatrixCounter][j] = j;
@@ -700,5 +704,5 @@
     input.open(file.str().c_str(), ios::in);
     if (input == NULL) {
-      DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl);
+      DoLog(0) && (Log() << Verbose(0) << endl << "ForceMatrix::ParseFragmentMatrix: Unable to open " << file.str() << ", is the directory correct?" << endl);
       return false;
     }
@@ -725,7 +729,7 @@
     // allocate last plus one matrix
     DoLog(0) && (Log() << Verbose(0) << "Allocating last plus one matrix with " << (RowCounter[MatrixCounter]+1) << " rows and " << ColumnCounter[MatrixCounter] << " columns." << endl);
-    Matrix[MatrixCounter] = Malloc<double*>(RowCounter[MatrixCounter] + 1, "MatrixContainer::ParseFragmentMatrix: **Matrix[]");
+    Matrix[MatrixCounter] = new double*[RowCounter[MatrixCounter] + 1];
     for(int j=0;j<=RowCounter[MatrixCounter];j++)
-      Matrix[MatrixCounter][j] = Malloc<double>(ColumnCounter[MatrixCounter], "MatrixContainer::ParseFragmentMatrix: *Matrix[][]");
+      Matrix[MatrixCounter][j] = new double[ColumnCounter[MatrixCounter]];
 
     // try independently to parse global forcesuffix file if present
@@ -754,10 +758,10 @@
   
   DoLog(0) && (Log() << Verbose(0) << "Parsing hessian indices for " << MatrixCounter << " matrices." << endl);
-  Indices = Malloc<int*>(MatrixCounter + 1, "HessianMatrix::ParseIndices: **Indices");
+  Indices = new int*[MatrixCounter + 1];
   line << name << FRAGMENTPREFIX << FORCESFILE;
   input.open(line.str().c_str(), ios::in);
   //Log() << Verbose(0) << "Opening " << line.str() << " ... "  << input << endl;
   if (input == NULL) {
-    DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << line.str() << ", is the directory correct?" << endl);
+    DoLog(0) && (Log() << Verbose(0) << endl << "HessianMatrix::ParseIndices: Unable to open " << line.str() << ", is the directory correct?" << endl);
     return false;
   }
@@ -767,8 +771,8 @@
     line.str(filename);
     // parse the values
-    Indices[i] = Malloc<int>(RowCounter[i], "HessianMatrix::ParseIndices: *Indices[]");
+    Indices[i] = new int[RowCounter[i]];
     FragmentNumber = FixedDigitNumber(MatrixCounter, i);
     //Log() << Verbose(0) << FRAGMENTPREFIX << FragmentNumber << "[" << RowCounter[i] << "]:";
-    Free(&FragmentNumber);
+    delete[](FragmentNumber);
     for(int j=0;(j<RowCounter[i]) && (!line.eof());j++) {
       line >> Indices[i][j];
@@ -777,5 +781,5 @@
     //Log() << Verbose(0) << endl;
   }
-  Indices[MatrixCounter] = Malloc<int>(RowCounter[MatrixCounter], "HessianMatrix::ParseIndices: *Indices[]");
+  Indices[MatrixCounter] = new int[RowCounter[MatrixCounter]];
   for(int j=RowCounter[MatrixCounter];j--;) {
     Indices[MatrixCounter][j] = j;
@@ -930,5 +934,5 @@
     input.open(file.str().c_str(), ios::in);
     if (input == NULL) {
-      DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl);
+      DoLog(0) && (Log() << Verbose(0) << endl << "HessianMatrix::ParseFragmentMatrix: Unable to open " << file.str() << ", is the directory correct?" << endl);
       return false;
     }
@@ -953,7 +957,7 @@
     // allocate last plus one matrix
     DoLog(0) && (Log() << Verbose(0) << "Allocating last plus one matrix with " << (RowCounter[MatrixCounter]+1) << " rows and " << ColumnCounter[MatrixCounter] << " columns." << endl);
-    Matrix[MatrixCounter] = Malloc<double*>(RowCounter[MatrixCounter] + 1, "MatrixContainer::ParseFragmentMatrix: **Matrix[]");
+    Matrix[MatrixCounter] = new double*[RowCounter[MatrixCounter] + 1];
     for(int j=0;j<=RowCounter[MatrixCounter];j++)
-      Matrix[MatrixCounter][j] = Malloc<double>(ColumnCounter[MatrixCounter], "MatrixContainer::ParseFragmentMatrix: *Matrix[][]");
+      Matrix[MatrixCounter][j] = new double[ColumnCounter[MatrixCounter]];
 
     // try independently to parse global forcesuffix file if present
@@ -985,11 +989,11 @@
 KeySetsContainer::~KeySetsContainer() {
   for(int i=FragmentCounter;i--;)
-    Free(&KeySets[i]);
+    delete[](KeySets[i]);
   for(int i=Order;i--;)
-    Free(&OrderSet[i]);
-  Free(&KeySets);
-  Free(&OrderSet);
-  Free(&AtomCounter);
-  Free(&FragmentsPerOrder);
+    delete[](OrderSet[i]);
+  delete[](KeySets);
+  delete[](OrderSet);
+  delete[](AtomCounter);
+  delete[](FragmentsPerOrder);
 };
 
@@ -1008,5 +1012,5 @@
   FragmentCounter = FCounter;
   DoLog(0) && (Log() << Verbose(0) << "Parsing key sets." << endl);
-  KeySets = Malloc<int*>(FragmentCounter, "KeySetsContainer::ParseKeySets: **KeySets");
+  KeySets = new int*[FragmentCounter];
   for(int i=FragmentCounter;i--;)
     KeySets[i] = NULL;
@@ -1014,19 +1018,19 @@
   input.open(file.str().c_str(), ios::in);
   if (input == NULL) {
-    DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl);
+    DoLog(0) && (Log() << Verbose(0) << endl << "KeySetsContainer::ParseKeySets: Unable to open " << file.str() << ", is the directory correct?" << endl);
     return false;
   }
 
-  AtomCounter = Malloc<int>(FragmentCounter, "KeySetsContainer::ParseKeySets: *RowCounter");
+  AtomCounter = new int[FragmentCounter];
   for(int i=0;(i<FragmentCounter) && (!input.eof());i++) {
     stringstream line;
     AtomCounter[i] = ACounter[i];
     // parse the values
-    KeySets[i] = Malloc<int>(AtomCounter[i], "KeySetsContainer::ParseKeySets: *KeySets[]");
+    KeySets[i] = new int[AtomCounter[i]];
     for(int j=AtomCounter[i];j--;)
       KeySets[i][j] = -1;
     FragmentNumber = FixedDigitNumber(FragmentCounter, i);
     //Log() << Verbose(0) << FRAGMENTPREFIX << FragmentNumber << "[" << AtomCounter[i] << "]:";
-    Free(&FragmentNumber);
+    delete[](FragmentNumber);
     input.getline(filename, 1023);
     line.str(filename);
@@ -1062,5 +1066,5 @@
 
   // scan through all to determine fragments per order
-  FragmentsPerOrder = Malloc<int>(Order, "KeySetsContainer::ParseManyBodyTerms: *FragmentsPerOrder");
+  FragmentsPerOrder = new int[Order];
   for(int i=Order;i--;)
     FragmentsPerOrder[i] = 0;
@@ -1076,7 +1080,7 @@
 
   // scan through all to gather indices to each order set
-  OrderSet = Malloc<int*>(Order, "KeySetsContainer::ParseManyBodyTerms: **OrderSet");
+  OrderSet = new int*[Order];
   for(int i=Order;i--;)
-    OrderSet[i] = Malloc<int>(FragmentsPerOrder[i], "KeySetsContainer::ParseManyBodyTermsKeySetsContainer::ParseManyBodyTerms: *OrderSet[]");
+    OrderSet[i] = new int[FragmentsPerOrder[i]];
   for(int i=Order;i--;)
     FragmentsPerOrder[i] = 0;
Index: src/periodentafel.cpp
===================================================================
--- src/periodentafel.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/periodentafel.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -45,4 +45,5 @@
 /** destructor for class periodentafel
  * Removes every element and afterwards deletes start and end of list.
+ * TODO: Handle when elements have changed and store databases then
  */
 periodentafel::~periodentafel()
@@ -275,5 +276,7 @@
 bool periodentafel::LoadElementsDatabase(istream *input)
 {
-  if ((*input) != NULL) {
+  bool status = true;
+  int counter = 0;
+  if (!(*input).fail()) {
     (*input).getline(header1, MAXSTRINGSIZE);
     (*input).getline(header2, MAXSTRINGSIZE); // skip first two header lines
@@ -300,5 +303,4 @@
       //(*input) >> ws;
       (*input) >> ws;
-      DoLog(0) && (Log() << Verbose(0) << " " << neues->symbol);
       if (elements.count(neues->Z)) {// if element already present, remove and delete it
         element * const Elemental = FindElement(neues->Z);
@@ -308,16 +310,22 @@
       }
       //neues->Output((ofstream *)&cout);
-      if ((neues->Z > 0) && (neues->Z < MAX_ELEMENTS))
+      if ((neues->Z > 0) && (neues->Z < MAX_ELEMENTS)) {
+        DoLog(0) && (Log() << Verbose(0) << " " << neues->symbol);
         elements[neues->getNumber()] = neues;
-      else {
-        DoLog(0) && (Log() << Verbose(0) << "Could not parse element: ");
-        neues->Output((ofstream *)&cout);
+        counter++;
+      } else {
+        DoeLog(2) && (eLog() << Verbose(2) << "Detected empty line or invalid element in elements db, discarding." << endl);
+        DoLog(0) && (Log() << Verbose(0) << " <?>");
         delete(neues);
       }
     }
     DoLog(0) && (Log() << Verbose(0) << endl);
-    return true;
-  } else
-    return false;
+  } else
+    status = false;
+
+  if (counter == 0)
+    status = false;
+
+  return status;
 }
 
@@ -329,5 +337,5 @@
 {
   char dummy[MAXSTRINGSIZE];
-  if ((*input) != NULL) {
+  if (!(*input).fail()) {
     (*input).getline(dummy, MAXSTRINGSIZE);
     while (!(*input).eof()) {
@@ -352,5 +360,5 @@
 {
   char dummy[MAXSTRINGSIZE];
-  if ((*input) != NULL) {
+  if (!(*input).fail()) {
     (*input).getline(dummy, MAXSTRINGSIZE);
     while (!(*input).eof()) {
@@ -375,5 +383,5 @@
 {
   char dummy[MAXSTRINGSIZE];
-  if ((*input) != NULL) {
+  if (!(*input).fail()) {
     (*input).getline(dummy, MAXSTRINGSIZE);
     while (!(*input).eof()) {
@@ -400,5 +408,5 @@
 {
   char dummy[MAXSTRINGSIZE];
-  if ((*input) != NULL) {
+  if (!(*input).fail()) {
     (*input).getline(dummy, MAXSTRINGSIZE);
     while (!(*input).eof()) {
Index: src/stackclass.hpp
===================================================================
--- src/stackclass.hpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/stackclass.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -50,5 +50,7 @@
 template <typename T> StackClass<T>::StackClass(int dimension) : StackList(NULL), EntryCount(dimension), CurrentLastEntry(0), CurrentFirstEntry(0), NextFreeField(0)
 {
-  StackList = Calloc<T>(EntryCount, "StackClass::StackClass: **StackList");
+  StackList = new T[EntryCount];
+  for (int i=0;i<EntryCount;i++)
+    StackList[i] = NULL;
 };
 
@@ -57,5 +59,5 @@
 template <typename T> StackClass<T>::~StackClass()
 {
-  Free(&StackList);
+  delete[](StackList);
 };
 
